
; ========================================================
;			
;    -- TransparentWindow.asm --
;			Jay Sullivan
; ========================================================
  

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;#################################################
;#                Header
;#################################################

		include TransparentWindow.inc
		
;#################################################
;#                Code
;#################################################

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		
;#################################################
;#                WinMain
;#################################################
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND

		;------------------------------------------------
		;	Main Window Register
		;------------------------------------------------
		
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset WndProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			invoke GetStockObject,BLACK_BRUSH
			mov wc.hbrBackground, eax
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset szClassName
			invoke LoadIcon, NULL, IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,0
			invoke LoadCursor, NULL, IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc
			invoke LoadMenu, hInst, Offset szMenuName
			mov hMenu,eax
			
		;------------------------------------------------
		;	Main Window Create
		;------------------------------------------------
		
			invoke CreateWindowEx, WS_EX_CLIENTEDGE or WS_EX_TOPMOST , Offset szClassName, ADDR szAppName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,CW_USEDEFAULT,250,250, NULL,hMenu,hInst,NULL
			mov hwnd,eax
			
		;-----------------------------
		;	Show Window
		;-----------------------------
		
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP


;#################################################
;#                WndProc
;#################################################

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL hdc:HDC,
	  ps:PAINTSTRUCT,
	  rcClient:RECT, 
	  hRegionOuter:HRGN,
	  hRegionInner:HRGN
	  
	;-----------------------------
	 .if uMsg==WM_DESTROY
	;-----------------------------
		
		invoke PostQuitMessage, NULL
		
	;-----------------------------
	 .elseif uMsg==WM_SIZE
	;-----------------------------
	
			.if bFrozen!=0
				invoke SendMessage,hWnd,WM_COMMAND,IDM_WINDOW_UNFREEZE,0
			.endif
			
			movzx eax, LOWORD(lParam)
			movzx ecx, HIWORD(lParam)
			add eax, 12
			add ecx, 63
			invoke CreateRectRgn,0,0,eax,ecx
			mov hRegionOuter,eax
			
			movzx eax, LOWORD(lParam)
			movzx ecx, HIWORD(lParam)
			add eax, 3
			add ecx, 49
			invoke CreateRectRgn,9,55,eax,ecx
			mov hRegionInner,eax
			
		    invoke CombineRgn,hRegionOuter, hRegionOuter, hRegionInner, RGN_XOR
		    invoke DeleteObject,hRegionInner
		    invoke SetWindowRgn,hWnd, hRegionOuter, TRUE
		     
	;-----------------------------
	 .elseif uMsg==WM_COMMAND
	;-----------------------------
	
		mov eax, wParam
		;-----------------------------
		.if ax==IDM_WINDOW_FREEZE
		;-----------------------------
		
				invoke EnableMenuItem,hMenu,IDM_WINDOW_FREEZE,MF_GRAYED
				mov bFrozen, TRUE
				
				invoke GetClientRect,hWnd,ADDR rcClient
		
				mov eax, rcClient.right
				mov ecx, rcClient.bottom
				add eax, 12
				add ecx, 63
				invoke CreateRectRgn,0,0,eax,ecx
				mov hRegionOuter,eax
				
			    invoke SetWindowRgn,hWnd, hRegionOuter, TRUE
			
		;------------------------------------
		.elseif ax==IDM_WINDOW_UNFREEZE
		;------------------------------------
		
				invoke EnableMenuItem,hMenu,IDM_WINDOW_FREEZE,MF_ENABLED
				mov bFrozen, FALSE
				
		;-----------------------------
		.endif
		;-----------------------------
		
	;-----------------------------
	 .elseif uMsg==WM_ERASEBKGND && bFrozen!=0
	;-----------------------------
	;-----------------------------
	 .else
	;-----------------------------
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP


End Start